# typedef TypeParamDecl

#### package haxe.macro

#### import haxe.macro.Expr

Available on all platforms

Represents a type parameter declaration in the AST.

### Properties

###

`constraints:Null<Array<ComplexType>>`

The optional constraints of the type parameter.

###

`meta:Null<Metadata>`

The metadata of the type parameter.

###

`name:String`

The name of the type parameter.

###

`params:Null<Array<TypeParamDecl>>`

The optional parameters of the type parameter.